#==========
#Scoreboard & Team Creation
#==========

scoreboard objectives add AbilityCooldown dummy
scoreboard objectives add AbilityReady dummy
scoreboard objectives add Ammo dummy
scoreboard objectives add Reload dummy
scoreboard objectives add Hunger food
scoreboard objectives add ReloadTicks dummy
scoreboard objectives add GrannySmithConsumed minecraft.used:snowball
scoreboard objectives add SoulsSaved dummy
scoreboard objectives add SoulsSavedRecord dummy
scoreboard objectives add Gold dummy
scoreboard objectives add SingleDing dummy
scoreboard objectives add Game dummy
scoreboard objectives add BossCount dummy
scoreboard objectives add SoulReignerCount dummy
scoreboard objectives add Elimination deathCount
scoreboard objectives add 5 dummy
scoreboard objectives add AbilityTicks dummy
scoreboard objectives add PlayersLeft dummy
scoreboard objectives add zombieKill minecraft.killed:minecraft.zombie
scoreboard objectives add huskKill minecraft.killed:minecraft.husk
scoreboard objectives add skeletonKill minecraft.killed:minecraft.skeleton
scoreboard objectives add pillagerKill minecraft.killed:minecraft.pillager
scoreboard objectives add vindicatorKill minecraft.killed:minecraft.vindicator
scoreboard objectives add ravagerKill minecraft.killed:minecraft.ravager
scoreboard objectives add piglinKill minecraft.killed:minecraft.piglin
scoreboard objectives add strayKill minecraft.killed:minecraft.stray
scoreboard objectives add drownedKill minecraft.killed:minecraft.drowned
scoreboard objectives add 1million dummy
scoreboard objectives add 50 dummy
scoreboard objectives add InLava dummy
scoreboard objectives add 10 dummy
scoreboard objectives add 20 dummy
scoreboard objectives add 30 dummy
scoreboard objectives add 133 dummy
scoreboard objectives add 67 dummy
scoreboard objectives add 0 dummy
scoreboard objectives add AdvancementTimer dummy
scoreboard objectives add Vulnerable dummy
scoreboard objectives add bit dummy
scoreboard objectives add BossTrigger dummy
scoreboard objectives add BossFight dummy
scoreboard objectives add BossHealth dummy
scoreboard objectives add WhiteGlass dummy
scoreboard objectives add Ring dummy
scoreboard objectives add Railgun used:warped_fungus_on_a_stick
scoreboard objectives add RailgunTimer dummy
scoreboard objectives add FIRIN dummy
scoreboard objectives add 200 dummy

scoreboard players set 0 0 0
scoreboard players set 5 5 5
scoreboard players set 50 50 50
scoreboard players set 10 10 10
scoreboard players set 20 20 20
scoreboard players set 30 30 30
scoreboard players set 133 133 133
scoreboard players set 67 67 67
scoreboard players set 200 200 200

execute as @a[team=] at @s run scoreboard players set @s AbilityReady 1
execute as @a[team=] at @s run scoreboard players set @s AbilityCooldown 0
execute as @a[team=] at @s run scoreboard players set @s Reload 0
execute as @a[team=] at @s run scoreboard players set @s ReloadTicks 0

team add Alive
team modify Alive friendlyFire false
team add Dead
team add Lobby
execute as @a[team=] at @s run team join Lobby @s
team add AliveBoss
team modify AliveBoss seeFriendlyInvisibles false
team modify AliveBoss friendlyFire false
team modify AliveBoss collisionRule never
team add DeadBoss

gamemode adventure @a[team=!Dead,tag=!dev,team=!DeadBoss]
gamemode spectator @a[team=Dead]
gamemode spectator @a[team=DeadBoss]
effect give @a[team=Lobby] resistance 1 127 true
effect give @a[team=Lobby] fire_resistance 1 127 true

#Hunger Moderation
execute as @a at @s if score @s Hunger matches 0 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 1 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 2 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 3 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 4 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 5 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 6 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 7 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 8 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 9 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 10 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 11 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 12 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 13 run effect give @s saturation 1 1 true
execute as @a at @s if score @s Hunger matches 20 run effect give @s hunger 2 127 true
execute as @a at @s if score @s Hunger matches 19 run effect give @s hunger 2 127 true
execute as @a at @s if score @s Hunger matches 18 run effect give @s hunger 2 127 true
execute as @a at @s if score @s Hunger matches 17 run effect give @s hunger 2 127 true
execute as @a at @s if score @s Hunger matches 16 run effect give @s hunger 2 127 true

#==========
#Weapons
#==========

#||Reload||
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s unless entity @s[tag=reloading] if score Active Game matches 1 if score @s Ammo matches 0 run scoreboard players set @s Reload 30
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s unless entity @s[tag=reloading] if score Active Game matches 1 if score @s Ammo matches 0 run tag @s add reloading
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s unless entity @s[tag=reloading] if score Active BossFight matches 1 if score @s Ammo matches 0 run scoreboard players set @s Reload 30
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s unless entity @s[tag=reloading] if score Active BossFight matches 1 if score @s Ammo matches 0 run tag @s add reloading
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if entity @s[tag=reloading] if score @s Ammo matches 0 unless score @s Reload matches 0 if score @s ReloadTicks matches 0 run scoreboard players set @s ReloadTicks 20
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if entity @s[tag=reloading] if score @s Ammo matches 0 unless score @s Reload matches 0 run scoreboard players remove @s ReloadTicks 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if entity @s[tag=reloading] if score @s Ammo matches 0 unless score @s Reload matches 0 if score @s ReloadTicks matches 0 run scoreboard players remove @s Reload 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if entity @s[tag=reloading] if score @s Reload matches 0 if score @s Ammo matches 0 at @s run playsound item.armor.equip_gold master @s ~ ~ ~ 1 1 1

execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MachineGun] at @s if entity @s[tag=reloading] if score @s Reload matches 0 if score @s Ammo matches 0 run scoreboard players set @s Ammo 100
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LightningSniper] at @s if entity @s[tag=reloading] if score @s Reload matches 0 if score @s Ammo matches 0 run give @s spectral_arrow{display:{Name:'{"text": "Conductive Arrows","color": "yellow","bold": true}'}} 5
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=BoomBow] at @s if entity @s[tag=reloading] if score @s Reload matches 0 if score @s Ammo matches 0 run give @s tipped_arrow{display:{Name:'{"text":"TNT Arrows","color":"yellow","bold":true}'},CustomPotionColor:16777215,CustomPotionEffects:[{Id:16,Duration:0,Amplifier:0b}]} 10
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=InfectedBarbarian] at @s if entity @s[tag=reloading] if score @s Reload matches 0 if score @s Ammo matches 0 run give @s snowball{display:{Name:'{"text": "Granny Smith Apple","color": "yellow","bold": true}',Lore:['{"text":"The chosen apple breed that bestows magical properties","color": "dark_purple","italic": true}']}} 3
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Rocketeer] at @s if entity @s[tag=reloading] if score @s Reload matches 0 if score @s Ammo matches 0 run scoreboard players set @s Ammo 3
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s if entity @s[tag=reloading] if score @s Reload matches 0 if score @s Ammo matches 0 run scoreboard players set @s Railgun 0
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s if entity @s[tag=reloading] if score @s Reload matches 0 if score @s Ammo matches 0 run scoreboard players set @s Ammo 4

execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if entity @s[tag=reloading] if score @s Reload matches 0 unless score @s Ammo matches 0 run tag @s remove reloading

#Machine Gun
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MachineGun,nbt={Inventory:[{id:"minecraft:crossbow",tag:{Charged:0b}}]}] unless score @s Ammo matches 0 at @s run scoreboard players remove @s Ammo 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MachineGun,nbt={Inventory:[{id:"minecraft:crossbow",tag:{Charged:0b}}]}] run clear @s crossbow{Charged:0b}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MachineGun] unless entity @s[nbt={Inventory:[{id:"minecraft:crossbow"}]}] unless score @s Ammo matches 0 at @s run give @s crossbow{display:{Name:'{"text":"Machine Gun","color":"yellow","bold":true}',Lore:['{"text":"Don\'t worry it has low recoil!","color":"dark_purple","italic":true}']},Unbreakable:1b,Enchantments:[{id:"minecraft:piercing",lvl:2s}],ChargedProjectiles:[{id:"minecraft:arrow",Count:1b},{},{}],Charged:1b} 1

#Lightning Sniper
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LightningSniper] store result score @s Ammo run data get entity @s Inventory[{id:"minecraft:spectral_arrow"}].Count
execute as @e[type=minecraft:spectral_arrow,nbt={inGround:0b}] at @s unless entity @e[type=player,distance=..5.5] unless entity @e[type=pig,distance=..6] run summon minecraft:lightning_bolt ~ ~ ~
item replace entity @a[tag=LightningSniper,team=!Dead,team=!DeadBoss,team=!Lobby] hotbar.0 with bow{Enchantments:[{id:"minecraft:power",lvl:3}],Unbreakable:true,display:{Name:'{"text":"Lightning Sniper","color": "yellow","bold": true}',Lore:['{"text":"Blessed by the Holy Cat Lady herself","color": "dark_purple","italic": true}']}}

#Boom Bow
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=BoomBow] store result score @s Ammo run data get entity @s Inventory[{id:"minecraft:tipped_arrow"}].Count
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=BoomBow] at @s run tag @e[type=#arrows,distance=0..1.75,nbt={CustomPotionEffects:[{Id:16,Duration:0,Amplifier:0b}]}] add BOOM
execute as @e[type=#arrows,tag=BOOM,nbt={inGround:1b,CustomPotionEffects:[{Id:16,Duration:0,Amplifier:0b}]}] at @s run summon creeper ~ ~ ~ {Silent:1b,Invulnerable:1b,ExplosionRadius:3b,Fuse:0,ignited:1b}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if entity @e[type=creeper,nbt={Silent:1b},distance=..5] run effect give @s minecraft:resistance 2 127 true
item replace entity @a[tag=BoomBow,team=!Dead,team=!DeadBoss,team=!Lobby] hotbar.0 with bow{Enchantments:[{id:"minecraft:power",lvl:5}],Unbreakable:true,display:{Name:'{"text":"Boom Bow","bold": true,"color": "yellow"}',Lore:['{"text":"Combustion sure beats taking your meds","italic": true,"color": "dark_purple"}']}}
item replace entity @a[tag=BoomBow,team=!Dead,team=!DeadBoss,team=!Lobby] hotbar.1 with stick{Enchantments:[{id:"minecraft:sharpness",lvl:8}],display:{Name:'{"text": "Musty Slipper","color": "yellow","bold":true}',Lore:['{"text": "*Sniff*","color": "dark_purple","italic":true}','{"text":"*Inhales Earwig*"}']}}

#Infected Barbarian
execute as @e[type=!player,type=!pig,type=!armor_stand] at @s if entity @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=InfectedBarbarian,distance=..3] run effect give @s wither 5 1 false
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=InfectedBarbarian] at @s store result score @s Ammo run data get entity @s Inventory[{id:"minecraft:snowball"}].Count

#Rocketeer
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Rocketeer,nbt={Inventory:[{id:"minecraft:crossbow",tag:{Charged:0b}}]}] unless score @s Ammo matches 0 at @s run scoreboard players remove @s Ammo 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Rocketeer,nbt={Inventory:[{id:"minecraft:crossbow",tag:{Charged:0b}}]}] run clear @s crossbow{Charged:0b}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Rocketeer] unless entity @s[nbt={Inventory:[{id:"minecraft:crossbow"}]}] unless score @s Ammo matches 0 at @s run give @s crossbow{display:{Name:'{"text":"Shoomer","color":"yellow","bold":true}',Lore:['{"text":"Unrelated to Amy or Chuck","color":"dark_purple","italic":true}']},Unbreakable:1b,ChargedProjectiles:[{id:"minecraft:firework_rocket",Count:1b,tag:{Fireworks:{Explosions:[{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b}],Flight:0.5b}}},{id:"minecraft:firework_rocket",Count:1b,tag:{Fireworks:{Explosions:[{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b}],Flight:0.5b}}},{id:"minecraft:firework_rocket",Count:1b,tag:{Fireworks:{Explosions:[{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b},{Type:1b,Colors:[I;16750111],Trail:1b}],Flight:0.5b}}}],Charged:1b,Enchantments:[{id:"minecraft:multishot",lvl:1}]} 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if entity @e[type=firework_rocket,nbt={LifeTime:1},distance=..5] run effect give @s resistance 1 127 true

#RailGun
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s Ammo > 0 0 if score @s Railgun > 0 0 if score @s RailgunTimer matches 0 run effect give @s slowness 2 127 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s Ammo > 0 0 if score @s Railgun > 0 0 if score @s RailgunTimer matches 0 run effect give @s resistance 3 50 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s Ammo > 0 0 if score @s Railgun > 0 0 if score @s RailgunTimer matches 0 run attribute @s generic.knockback_resistance base set 1.0
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s Ammo > 0 0 if score @s Railgun > 0 0 if score @s RailgunTimer matches 0 run playsound minecraft:block.beacon.activate master @a ~ ~ ~ 1 2 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s Ammo > 0 0 if score @s Railgun > 0 0 run scoreboard players add @s RailgunTimer 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s Ammo > 0 0 if score @s Railgun > 0 0 if score @s RailgunTimer matches 30 run playsound minecraft:block.bone_block.break master @a ~ ~ ~ 1 1 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s Ammo > 0 0 if score @s Railgun > 0 0 if score @s RailgunTimer matches 30 run function gg:raycast_railgun
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s Ammo > 0 0 if score @s Railgun > 0 0 if score @s RailgunTimer matches 30 if score LAZOR FIRIN >= 10 10 run advancement grant @s only gg:shoop_da_whoop
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s Ammo > 0 0 if score @s Railgun > 0 0 if score @s RailgunTimer matches 30 run scoreboard players set LAZOR FIRIN 0
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s Ammo > 0 0 if score @s Railgun > 0 0 if score @s RailgunTimer matches 30 run attribute @s generic.knockback_resistance base set 0.0
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s Railgun > 0 0 if score @s RailgunTimer matches 30 run scoreboard players set @s Railgun 0
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s RailgunTimer matches 30 unless score @s Ammo <= 0 0 run scoreboard players remove @s Ammo 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s RailgunTimer matches 30 run effect clear @s slowness
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=Railgun] at @s anchored eyes if score @s RailgunTimer matches 30 run scoreboard players set @s RailgunTimer 0


#||Kill Arrows||
kill @e[type=arrow,nbt={inGround:1b}]
kill @e[type=spectral_arrow,nbt={inGround:1b}]

#||Granny Smith Apples||
kill @e[type=snowball]
execute as @a at @s if score @s GrannySmithConsumed matches 1 run stopsound @s * entity.snowball.throw
execute as @a at @s if score @s GrannySmithConsumed matches 1 run playsound yummy.in_my_tummy master @a ~ ~ ~ 1 1 1
execute as @a at @s if score @s GrannySmithConsumed matches 1 run effect give @s regeneration 2 127 true
execute as @a at @s if score @s GrannySmithConsumed matches 1 run effect give @s resistance 4 1 true
execute as @a at @s if score @s GrannySmithConsumed matches 1 run effect give @s speed 6 0 true
execute as @a at @s if score @s GrannySmithConsumed matches 1 run scoreboard players set @s GrannySmithConsumed 0

#==========
#Abilities
#==========

execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s unless score @s AbilityCooldown matches 0 unless score @s AbilityTicks matches 0 run scoreboard players remove @s AbilityTicks 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if score @s AbilityTicks matches 0 run scoreboard players remove @s AbilityCooldown 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if score @s AbilityTicks matches 0 run scoreboard players set @s AbilityTicks 20
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if score @s AbilityCooldown matches 0 if score @s AbilityReady matches 0 run playsound block.anvil.land master @s ~ ~ ~ 1 1 1

execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if score @s AbilityCooldown matches 0 if score @s AbilityReady matches 0 run give @s[tag=MobilityScooter] cornflower{display:{Name:'{"text":"Mobility Scooter Keys","color":"yellow","bold":true}',Lore:['{"text":"They really should lock up that rocket fuel","color":"dark_purple","italic": true}','{"text":"SWITCH TO OFFHAND TO USE","bold": true,"color":"dark_green"}']}}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if score @s AbilityCooldown matches 0 if score @s AbilityReady matches 0 run give @s[tag=BingoNight] dandelion{display:{Name:'{"text":"Bingo Night","color":"yellow","bold":true}',Lore:['{"text":"STOP SPINNING AND START CALLING NUMBERS MARTHA!!","color":"dark_purple","italic": true}','{"text":"SWITCH TO OFFHAND TO USE","bold": true,"color":"dark_green"}']}}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if score @s AbilityCooldown matches 0 if score @s AbilityReady matches 0 run give @s[tag=HealthyDiet] red_tulip{display:{Name:'{"text":"Healthy Diet","color":"yellow","bold":true}',Lore:['{"text":"Skittles are kinda like fruit","color":"dark_purple","italic": true}','{"text":"SWITCH TO OFFHAND TO USE","bold": true,"color":"dark_green"}']}}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if score @s AbilityCooldown matches 0 if score @s AbilityReady matches 0 run give @s[tag=LastWish] orange_tulip{display:{Name:'{"text":"Last Wish","color":"yellow","bold":true}',Lore:['{"text":"I can get a new hearing aid before I kick the bucket","color":"dark_purple","italic": true}','{"text":"SWITCH TO OFFHAND TO USE","bold": true,"color":"dark_green"}']}}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if score @s AbilityCooldown matches 0 if score @s AbilityReady matches 0 run give @s[tag=SkydivingAt100] pink_tulip{display:{Name:'{"text":"Parachute","color":"yellow","bold":true}',Lore:['{"text":"The wind in my gums makes me feel alive!","color":"dark_purple","italic": true}','{"text":"SWITCH TO OFFHAND TO USE","bold": true,"color":"dark_green"}']}}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if score @s AbilityCooldown matches 0 if score @s AbilityReady matches 0 run give @s[tag=FeelingAlive] white_tulip{display:{Name:'{"text":"Roller Blades","color":"yellow","bold":true}',Lore:['{"text":"Arthritis is a myth","color":"dark_purple","italic": true}','{"text":"SWITCH TO OFFHAND TO USE","bold": true,"color":"dark_green"}']}}

execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby] at @s if score @s AbilityCooldown matches 0 if score @s AbilityReady matches 0 run scoreboard players set @s AbilityReady 1

kill @e[type=experience_orb]

#Rocket Powered Mobility Scooter
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:cornflower",Slot:-106b}]}] at @s run summon pig ~ ~ ~ {Silent:1b,Invulnerable:1b,Saddle:1b,Attributes:[{Name:"generic.movement_speed",Base:1}],Tags:[Scooter],DeathLootTable:"gg:nothing"}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:cornflower",Slot:-106b}]}] at @s run scoreboard players set @s AbilityCooldown 60
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:cornflower",Slot:-106b}]}] at @s run xp set @s 12 levels
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:cornflower",Slot:-106b}]}] at @s run xp set @s 0 points
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter,scores={AbilityReady=0},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b}]}] at @s run xp add @s -1 points
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:cornflower",Slot:-106b}]}] at @s run item replace entity @s weapon.offhand with carrot_on_a_stick{display:{Name:'{"text":"Mobility Scooter Keys","color":"yellow","bold":true}',Lore:['{"text":"They really should lock up that rocket fuel","color":"dark_purple","italic": true}']}}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter] unless entity @s[tag=MobilityScooter,nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b}]}] run xp set @s 0 levels
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter] unless entity @s[tag=MobilityScooter,nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b}]}] run xp set @s 0 points
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter] unless entity @s[tag=MobilityScooter,nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b}]}] run clear @s carrot_on_a_stick
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter] unless entity @s[tag=MobilityScooter,nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b}]}] at @s run kill @e[type=pig,tag=Scooter]
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter,scores={AbilityReady=0},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b}]}] if entity @s[nbt={XpP:0f,XpLevel:0}] at @s run kill @e[type=pig,tag=Scooter,distance=..1]
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter,scores={AbilityReady=0},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b}]}] at @s run ride @s mount @e[type=pig,sort=nearest,distance=..2,limit=1]
kill @e[type=item,nbt={Item:{id:"minecraft:saddle"}}]
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter,scores={AbilityReady=0},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b}]}] if entity @s[nbt={XpP:0f,XpLevel:0}] at @s run clear @s carrot_on_a_stick
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=MobilityScooter,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:carrot_on_a_stick",Slot:-106b}]}] at @s run scoreboard players set @s AbilityReady 0

execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,nbt={RootVehicle:{Entity:{id:"minecraft:pig"}}}] at @s run effect give @s resistance 1 127 true

execute as @e[type=pig] at @s if entity @e[type=!player,type=!pig,distance=..1] run effect give @e[type=!player,type=!pig,distance=..1] minecraft:levitation 1 18 true
execute as @e[type=pig] at @s if block ~ ~-1 ~ lava run tp @s ~ ~ ~

#Bingo Night
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=BingoNight,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:dandelion",Slot:-106b}]}] at @s run execute as @e[type=!player,type=!pig] at @s run effect give @s slowness 11 255
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=BingoNight,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:dandelion",Slot:-106b}]}] at @s run scoreboard players set @s AbilityCooldown 60
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=BingoNight,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:dandelion",Slot:-106b}]}] at @s run xp set @s 12 levels
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=BingoNight,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:dandelion",Slot:-106b}]}] at @s run xp set @s 0 points
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=BingoNight,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:dandelion",Slot:-106b}]}] at @s run scoreboard players set @s AbilityReady 0
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=BingoNight,nbt={Inventory:[{id:"minecraft:dandelion",Slot:-106b}]}] at @s run clear @s dandelion
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=BingoNight] unless entity @s[nbt={XpP:0f,XpLevel:0},scores={AbilityReady=0}] run xp add @s -1 points

#Healthy Diet
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=HealthyDiet,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:red_tulip",Slot:-106b}]}] at @s run xp set @s 12 levels
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=HealthyDiet,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:red_tulip",Slot:-106b}]}] at @s run xp set @s 0 points
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=HealthyDiet,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:red_tulip",Slot:-106b}]}] at @s run scoreboard players set @s AbilityCooldown 60
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=HealthyDiet,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:red_tulip",Slot:-106b}]}] run effect give @s absorption 11 4 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=HealthyDiet,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:red_tulip",Slot:-106b}]}] run effect give @s regeneration 11 3 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=HealthyDiet,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:red_tulip",Slot:-106b}]}] at @s run scoreboard players set @s AbilityReady 0
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=HealthyDiet,scores={AbilityReady=0},nbt={Inventory:[{id:"minecraft:red_tulip",Slot:-106b}]}] run clear @s red_tulip
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=HealthyDiet] unless entity @s[nbt={XpP:0f,XpLevel:0},scores={AbilityReady=0}] run xp add @s -1 points

#Last Wish
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:orange_tulip",Slot:-106b}]}] at @s run xp set @s 12 levels
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:orange_tulip",Slot:-106b}]}] at @s run xp set @s 0 points
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:orange_tulip",Slot:-106b}]}] at @s run scoreboard players set @s AbilityCooldown 60
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:orange_tulip",Slot:-106b}]}] at @s run effect give @s resistance 11 255 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:orange_tulip",Slot:-106b}]}] at @s run effect give @s slowness 11 127 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:orange_tulip",Slot:-106b}]}] at @s run effect give @s regeneration 30 1 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:orange_tulip",Slot:-106b}]}] at @s run effect give @s instant_health 1 127 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:orange_tulip",Slot:-106b}]}] at @s run effect give @s instant_damage 1 2 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:orange_tulip",Slot:-106b}]}] at @s run attribute @s minecraft:generic.max_health base set 1
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:orange_tulip",Slot:-106b}]}] at @s run scoreboard players set @s AbilityReady 0
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish,scores={AbilityReady=0},nbt={Inventory:[{id:"minecraft:orange_tulip",Slot:-106b}]}] run clear @s orange_tulip
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish] unless entity @s[nbt={XpP:0f,XpLevel:0}] if entity @s[nbt={Attributes:[{Base:1.0d,Name:"minecraft:generic.max_health"}]}] at @s run effect give @a[distance=..13] resistance 2 255 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish] unless entity @s[nbt={XpP:0f,XpLevel:0}] if entity @s[nbt={Attributes:[{Base:1.0d,Name:"minecraft:generic.max_health"}]}] at @s run summon creeper ~ ~3.5 ~ {Silent:1b,Invulnerable:1b,ExplosionRadius:2b,Fuse:0,ignited:1b}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish] unless entity @s[nbt={XpP:0f,XpLevel:0}] if entity @s[nbt={Attributes:[{Base:1.0d,Name:"minecraft:generic.max_health"}]}] at @s run summon creeper ~5.5 ~ ~ {Silent:1b,Invulnerable:1b,ExplosionRadius:2b,Fuse:0,ignited:1b}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish] unless entity @s[nbt={XpP:0f,XpLevel:0}] if entity @s[nbt={Attributes:[{Base:1.0d,Name:"minecraft:generic.max_health"}]}] at @s run summon creeper ~ ~ ~5.5 {Silent:1b,Invulnerable:1b,ExplosionRadius:2b,Fuse:0,ignited:1b}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish] unless entity @s[nbt={XpP:0f,XpLevel:0}] if entity @s[nbt={Attributes:[{Base:1.0d,Name:"minecraft:generic.max_health"}]}] at @s run summon creeper ~-5.5 ~ ~ {Silent:1b,Invulnerable:1b,ExplosionRadius:2b,Fuse:0,ignited:1b}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish] unless entity @s[nbt={XpP:0f,XpLevel:0}] if entity @s[nbt={Attributes:[{Base:1.0d,Name:"minecraft:generic.max_health"}]}] at @s run summon creeper ~ ~ ~-5.5 {Silent:1b,Invulnerable:1b,ExplosionRadius:2b,Fuse:0,ignited:1b}
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish] unless entity @s[nbt={XpP:0f,XpLevel:0},scores={AbilityReady=0}] run xp add @s -1 points
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=LastWish] if entity @s[nbt={XpP:0f,XpLevel:0},scores={AbilityReady=0}] run attribute @s minecraft:generic.max_health base set 20

#Skydive at 100
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=SkydivingAt100,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:pink_tulip",Slot:-106b}]}] at @s run xp set @s 12 levels
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=SkydivingAt100,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:pink_tulip",Slot:-106b}]}] at @s run xp set @s 0 points
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=SkydivingAt100,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:pink_tulip",Slot:-106b}]}] at @s run scoreboard players set @s AbilityCooldown 60
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=SkydivingAt100,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:pink_tulip",Slot:-106b}]}] at @s run effect give @s levitation 1 54 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=SkydivingAt100,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:pink_tulip",Slot:-106b}]}] at @s run effect give @s slow_falling 11 0 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=SkydivingAt100,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:pink_tulip",Slot:-106b}]}] at @s run effect give @s resistance 11 127 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=SkydivingAt100,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:pink_tulip",Slot:-106b}]}] at @s run scoreboard players set @s AbilityReady 0
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=SkydivingAt100,scores={AbilityReady=0},nbt={Inventory:[{id:"minecraft:pink_tulip",Slot:-106b}]}] run clear @s pink_tulip
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=SkydivingAt100] unless entity @s[nbt={XpP:0f,XpLevel:0},scores={AbilityReady=0}] run xp add @s -1 points

#Feeling Alive
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=FeelingAlive,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:white_tulip",Slot:-106b}]}] at @s run xp set @s 12 levels
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=FeelingAlive,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:white_tulip",Slot:-106b}]}] at @s run xp set @s 0 points
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=FeelingAlive,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:white_tulip",Slot:-106b}]}] at @s run scoreboard players set @s AbilityCooldown 60
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=FeelingAlive,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:white_tulip",Slot:-106b}]}] at @s run effect give @s speed 11 4 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=FeelingAlive,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:white_tulip",Slot:-106b}]}] at @s run effect give @s jump_boost 11 9 true
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=FeelingAlive,scores={AbilityReady=1},nbt={Inventory:[{id:"minecraft:white_tulip",Slot:-106b}]}] at @s run scoreboard players set @s AbilityReady 0
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=FeelingAlive,scores={AbilityReady=0},nbt={Inventory:[{id:"minecraft:white_tulip",Slot:-106b}]}] run clear @s white_tulip
execute as @a[team=!Dead,team=!DeadBoss,team=!Lobby,tag=FeelingAlive] unless entity @s[nbt={XpP:0f,XpLevel:0},scores={AbilityReady=0}] run xp add @s -1 points

#==========
#Lobby Shenanigans
#==========

#||Parkour Ending||
execute as @a at @s if entity @s[x=-86,dx=-1,y=-43,dy=1,dz=1,z=-34] run setblock -38 -36 -32 air
execute as @a at @s if entity @s[x=-86,dx=-1,y=-43,dy=1,dz=1,z=-34] run tp @s -51.5 -37 -45.5
execute as @a at @s if entity @s[x=-51.5,y=-37,z=-45.5,dx=1,dy=1,dz=1] run playsound ambient.cave master @s ~ ~ ~ 1 1 1

#||Lobby Music Activation||
execute as @a at @s if block -32 -34 -47 dark_oak_button[powered=true,face=floor,facing=east] run stopsound @s
execute as @a at @s if block -32 -34 -47 dark_oak_button[powered=true,face=floor,facing=east] run playsound minecraft:lobby.music ambient @s ~ ~ ~ 1 1 1

#||Start Button||
execute as @a at @s if block -37 -34 -35 polished_blackstone_button[powered=true] if score @s SingleDing matches 0 run stopsound @s master block.note_block.chime
execute as @a at @s if block -37 -34 -35 polished_blackstone_button[powered=true] if score @s SingleDing matches 0 run playsound block.note_block.chime master @s ~ ~ ~ 1 1 1
execute as @a at @s if block -37 -34 -35 polished_blackstone_button[powered=true] if score @s SingleDing matches 0 run schedule function gg:single_ding 1.1s
execute if block -37 -34 -35 polished_blackstone_button[powered=true] at @e[type=marker,tag=StartLimiter] unless score @p SingleDing matches 1 unless entity @a[tag=!MachineGun,tag=!BoomBow,tag=!Railgun,tag=!LightningSniper,tag=!Rocketeer,tag=!InfectedBarbarian] unless entity @a[tag=!LastWish,tag=!MobilityScooter,tag=!FeelingAlive,tag=!BingoNight,tag=!HealthyDiet,tag=!SkydivingAt100] run function gg:start
execute if block -37 -34 -35 polished_blackstone_button[powered=true] at @e[type=marker,tag=StartLimiter] unless score @p SingleDing matches 1 if entity @a[tag=!MachineGun,tag=!BoomBow,tag=!Railgun,tag=!LightningSniper,tag=!Rocketeer,tag=!InfectedBarbarian] if entity @a[tag=!LastWish,tag=!MobilityScooter,tag=!FeelingAlive,tag=!BingoNight,tag=!HealthyDiet,tag=!SkydivingAt100] run tellraw @a [{"text": "<Receptionist> I'm sorry, everyone must select a kit and special before descending into Heck.","color":"gold"}]
execute if block -37 -34 -35 polished_blackstone_button[powered=true] at @e[type=marker,tag=StartLimiter] unless score @p SingleDing matches 1 if entity @a[tag=!MachineGun,tag=!BoomBow,tag=!Railgun,tag=!LightningSniper,tag=!Rocketeer,tag=!InfectedBarbarian] unless entity @a[tag=!LastWish,tag=!MobilityScooter,tag=!FeelingAlive,tag=!BingoNight,tag=!HealthyDiet,tag=!SkydivingAt100] run tellraw @a [{"text": "<Receptionist> I'm sorry, everyone must select a kit and special before descending into Heck.","color":"gold"}]
execute if block -37 -34 -35 polished_blackstone_button[powered=true] at @e[type=marker,tag=StartLimiter] unless score @p SingleDing matches 1 unless entity @a[tag=!MachineGun,tag=!BoomBow,tag=!Railgun,tag=!LightningSniper,tag=!Rocketeer,tag=!InfectedBarbarian] if entity @a[tag=!LastWish,tag=!MobilityScooter,tag=!FeelingAlive,tag=!BingoNight,tag=!HealthyDiet,tag=!SkydivingAt100] run tellraw @a [{"text": "<Receptionist> I'm sorry, everyone must select a kit and special before descending into Heck.","color":"gold"}]
execute as @a at @s if block -37 -34 -35 polished_blackstone_button[powered=true] if score @s SingleDing matches 0 run scoreboard players set @s SingleDing 1

#||Dud Bell||
execute as @a at @s if block -37 -34 -31 polished_blackstone_button[powered=true] if score @s SingleDing matches 0 run stopsound @s master block.note_block.chime
execute as @a at @s if block -37 -34 -31 polished_blackstone_button[powered=true] if score @s SingleDing matches 0 run playsound block.note_block.chime master @s ~ ~ ~ 1 1 1
execute as @a at @s if block -37 -34 -31 polished_blackstone_button[powered=true] if score @s SingleDing matches 0 run schedule function gg:single_ding 1.1s
execute as @a at @s if block -37 -34 -31 polished_blackstone_button[powered=true] if score @s SingleDing matches 0 run scoreboard players set @s SingleDing 1

#||Actionbar for Lobby||
title @a[team=Lobby] actionbar ["",{"text":"High Score: ","bold":true,"color":"yellow"},{"score":{"name":"Number","objective":"SoulsSavedRecord"},"color":"yellow"},{"text":" Gold: ","bold":true,"color":"gold"},{"score":{"name":"Wallet","objective":"Gold"},"color":"gold"}]

#||World Spawn||
setworldspawn -13 -29 -33 90
execute as @a at @s if block ~ ~-1 ~ white_terracotta run tp @s -13.0 -29 -33.0 facing -16.0 -28.5 -33.0

#||Purchasing Rooms||
execute as @a[team=Lobby] if score Wallet Gold >= 50 50 at @s if block ~ ~-3 ~ polished_andesite run data merge entity @e[type=text_display,limit=1,distance=..2,sort=nearest] {view_range:.000001f}
execute as @a[team=Lobby] if score Wallet Gold >= 50 50 at @s if block ~ ~-3 ~ polished_andesite run playsound block.note_block.harp master @a ~ ~ ~ 1 1 1
execute as @a[team=Lobby] if score Wallet Gold >= 50 50 at @s if block ~ ~-3 ~ polished_andesite run setblock ~ ~-2 ~ redstone_torch
execute as @a[team=Lobby] if score Wallet Gold >= 50 50 at @s if block ~ ~-3 ~ polished_andesite run scoreboard players remove Wallet Gold 50
execute as @a[team=Lobby] at @s if block ~ ~-2 ~ redstone_torch if block ~ ~-3 ~ polished_andesite run setblock ~ ~-3 ~ white_concrete

#||Boss Fight Start||
execute if block -20 -34 -44 chest{Items:[{id:"minecraft:sea_pickle"}]} run clear @a
execute if block -20 -34 -44 chest{Items:[{id:"minecraft:sea_pickle"}]} run execute as @a at @s run playsound minecraft:francis.perfect master @s ~ ~ ~ 1 1 1
execute if block -20 -34 -44 chest{Items:[{id:"minecraft:sea_pickle"}]} run schedule function gg:bad_guy 1s
execute if block -20 -34 -44 chest{Items:[{id:"minecraft:sea_pickle"}]} if score Done bit matches 0 run schedule function gg:prepare_to_die 65t
execute if block -20 -34 -44 chest{Items:[{id:"minecraft:sea_pickle"}]} if score Done bit matches 0 run schedule function gg:bit 4s
execute if block -20 -34 -44 chest{Items:[{id:"minecraft:sea_pickle"}]} if score Done bit matches 1 run schedule function gg:boss_start 65t
execute if block -20 -34 -44 chest{Items:[{id:"minecraft:sea_pickle"}]} run setblock -20 -34 -44 cave_air
execute if block -20 -34 -44 cave_air run setblock -20 -34 -44 chest[facing=south]

#||Josh||
execute as @e[type=minecraft:armor_stand,name=IDntLkOutside] at @s run tp @s ~ ~ ~ facing ^9 ^ ^-10

#==========
#Bosses
#==========

#||Boss Count||
scoreboard players set Number BossCount 0
execute as @e[tag=Boss] run scoreboard players add Number BossCount 1

#||Meat Shield||
execute as @e[type=stray,tag=Boss,tag=MeatShield] at @s run effect give @e[type=!player,type=!pig,type=!magma_cube,distance=..7,tag=!MeatShield] resistance 1 2 false
execute as @e[type=!player,type=!pig,nbt={ActiveEffects:[{Id:11}]},type=!armor_stand,nbt={IsBaby:0b}] at @s run particle dust 0.024 0.529 0.733 3 ~ ~ ~ .25 1 .25 10000 1 force
execute as @e[type=!player,type=!pig,nbt={ActiveEffects:[{Id:11}]},type=!armor_stand,nbt={IsBaby:1b}] at @s run particle dust 0.024 0.529 0.733 3 ~ ~ ~ .25 .25 .25 10000 1 force

#||Soul Reigner||
execute as @e[tag=SoulReigner,tag=Boss] at @s run tp @e[type=magma_cube,tag=Shield1,tag=Protection] ^ ^1 ^-1 
execute as @e[tag=SoulReigner,tag=Boss] at @s run tp @e[type=magma_cube,tag=Shield2,tag=Protection] ^1 ^1 ^ 
execute as @e[tag=SoulReigner,tag=Boss] at @s run tp @e[type=magma_cube,tag=Shield3,tag=Protection] ^-1 ^1 ^ 
execute as @e[tag=SoulReigner,tag=Boss] at @s if entity @e[type=magma_cube,tag=Protection,distance=..2] run effect give @s resistance 1 255 true

execute unless entity @e[tag=SoulReigner,tag=Boss] run scoreboard players set Number SoulReignerCount 0
execute as @e[tag=SoulReigner,tag=Boss] at @s if entity @s run scoreboard players set Number SoulReignerCount 1


execute as @e[tag=SoulReigner,tag=Boss] at @s if block ~ ~ ~ lava run kill @e[distance=..1.5,limit=3,type=magma_cube]
execute as @e[tag=SoulReigner,tag=Boss] at @s if block ~ ~ ~ lava run kill @s

#==========
#Misc. Gameplay
#==========
 
#||Spectator Boundaries||
execute as @a[team=Dead] at @s unless entity @s[x=-64,dx=100,y=-50,dy=200,z=57,dz=100] run tp @s -27 -37 108

#||In Game Actionbar||
execute as @a[team=Alive] if score Start Game matches 1 run title @s actionbar ["",{"text":"Ammo:","bold":true,"color":"green"},{"text":" ","color":"green"},{"score":{"objective":"Ammo","name": "@s"},"color":"green"},{"text":" Reload: ","bold":true,"color":"dark_green"},{"score":{"name":"@s","objective":"Reload"},"color":"dark_green"},{"text":"s ","color":"dark_green"},{"text":"Ability: ","bold":true,"color":"yellow"},{"score":{"name":"@s","objective":"AbilityCooldown"},"bold":false,"color":"yellow"},{"text":"s","color":"yellow","bold": false},{"text":" Souls: ","bold":true,"color":"gold"},{"score":{"name":"Number","objective":"SoulsSaved"},"color":"gold"}]

#||Death Detection||
execute as @a[team=Alive] if score Active Game matches 0 if score Start Game matches 1 at @s if block ~ ~-.5 ~ lava run tp @s -27 -37 108
execute as @a[team=Alive] if score @s Elimination matches 1 run team join Dead

#||Soul Deposition and Counting||
execute as @e[type=item,nbt={Item:{id:"minecraft:minecart"}}] at @s if block ~ ~-1 ~ beacon run scoreboard players add Number SoulsSaved 1
execute as @e[type=item,nbt={Item:{id:"minecraft:minecart"}}] at @s if block ~ ~-1 ~ beacon run kill @s

#||Solo Soul Collection||
execute as @a[nbt={Inventory:[{id:"minecraft:minecart",Count:1b}]}] at @s if entity @e[type=item,distance=..5,nbt={Item:{id:"minecraft:minecart"}}] run execute as @e[type=item,distance=..5,nbt={Item:{id:"minecraft:minecart"}}] run data merge entity @s {PickupDelay:20}

#||Game Over Detection||
scoreboard players set Number PlayersLeft 0
execute as @a[team=Alive] run scoreboard players add Number PlayersLeft 1
execute if score Number PlayersLeft matches 0 if score Active Game matches 1 run function gg:game_over

#||Souls Don't Die||
execute as @e[type=item,nbt={Item:{id:"minecraft:minecart",Count:1b}}] at @s run data merge entity @s {Invulnerable:1b}

#||Pig Die if in Lava||
execute as @e[type=pig] at @s if block ~ ~-1 ~ lava run kill @s

#==========
#Advancements
#==========

#||Get Rekt||
execute as @a[tag=Rocketeer] at @s run scoreboard players operation @a zombieKill += @s huskKill
execute as @a[tag=Rocketeer] at @s run scoreboard players operation @a zombieKill += @s skeletonKill
execute as @a[tag=Rocketeer] at @s run scoreboard players operation @a zombieKill += @s pillagerKill
execute as @a[tag=Rocketeer] at @s run scoreboard players operation @a zombieKill += @s vindicatorKill
execute as @a[tag=Rocketeer] at @s run scoreboard players operation @a zombieKill += @s ravagerKill
execute as @a[tag=Rocketeer] at @s run scoreboard players operation @a zombieKill += @s piglinKill
execute as @a[tag=Rocketeer] at @s run scoreboard players operation @a zombieKill += @s strayKill
execute as @a[tag=Rocketeer] at @s run scoreboard players operation @a zombieKill += @s drownedKill

execute as @a[tag=Rocketeer] at @s if score @s zombieKill >= 5 5 run advancement grant @s only gg:great_ball_of_fire

scoreboard players set @a zombieKill 0
scoreboard players set @a huskKill 0
scoreboard players set @a skeletonKill 0
scoreboard players set @a pillagerKill 0
scoreboard players set @a vindicatorKill 0
scoreboard players set @a ravagerKill 0
scoreboard players set @a piglinKill 0
scoreboard players set @a strayKill 0
scoreboard players set @a drownedKill 0

#||Backrooms||
execute as @a[advancements={gg:backrooms=false}] at @s if block ~ ~-2 ~ polished_diorite run schedule function gg:francis_start 6s
execute as @a at @s if block ~ ~-2 ~ polished_diorite run advancement grant @s only gg:backrooms

#||Bear||
execute as @a at @s if entity @s[advancements={gg:bear=false,gg:backrooms=false}] if entity @e[type=sheep,name="Bear #7",distance=..1] run tellraw @a [{"text":"[Bear #7] ","bold": true, "color": "gold"},{"text":"Hey, in case you couldn't tell I'm not from around here.\n","bold": false},{"text":"[Bear #7] ","bold": true, "color": "gold"},{"text":"I'm here on a special assignment to find a space anamoly, but I kinda got stuck being a cafeteria worker because this place is shorthanded.\n","bold": false},{"text":"[Bear #7] ","bold": true, "color": "gold"},{"text":"My devices are telling me that something by the statue labelled \"Map Creator\" is off. Report back and I will give you a reward.","bold": false}]
execute as @a at @s if entity @s[advancements={gg:bear=false,gg:backrooms=true}] if entity @e[type=sheep,name="Bear #7",distance=..1] run give @a sea_pickle{display:{Name:'[{"text": "Autographed Selfie","bold":true,"color": "yellow"}]',Lore:['{"text":"You GOT that from Bear #7!?!","color": "dark_purple","italic": true}','{"text":"That\'s gotta at least be worth $1,000,000","color": "dark_purple","italic": true}']}}
execute as @a at @s if entity @s[advancements={gg:bear=false,gg:backrooms=true}] if entity @e[type=sheep,name="Bear #7",distance=..1] run tellraw @a [{"text":"[Bear #7] ","bold": true, "color": "gold"},{"text":"Hey, in case you couldn't tell I'm not from around here.\n","bold": false},{"text":"[Bear #7] ","bold": true, "color": "gold"},{"text":"I'm here on a special assignment to find a space anamoly, but-\n","bold": false},{"text":"[Bear #7] ","bold": true, "color": "gold"},{"text": "Wait you already found it?\n","bold": false},{"text":"[Bear #7] ","bold": true, "color": "gold"},{"text": "Phew! If Francis is there that means he is secure, as long as no one gives him money all should be good!\n","bold": false},{"text":"[Bear #7] ","bold": true},{"text": "Thanks for the intel here's a reward!","bold": false}]
execute as @a at @s if entity @s[advancements={gg:bear=true,gg:backrooms=true},nbt=!{Inventory:[{id:"minecraft:sea_pickle"}]}] if entity @e[type=sheep,name="Bear #7",distance=..1] unless entity @e[type=item,distance=..4,nbt={Item:{id:"minecraft:sea_pickle"}}] run tellraw @a [{"text":"[Bear #7] ","bold": true, "color": "gold"},{"text":"Well that's a relief, I'm glad he's still there.\n","bold": false},{"text":"[Bear #7] ","bold": true, "color": "gold"},{"text":"Thanks for your help, here is your reward","bold": false}]
execute as @a at @s if entity @s[advancements={gg:bear=true,gg:backrooms=true},nbt=!{Inventory:[{id:"minecraft:sea_pickle"}]}] if entity @e[type=sheep,name="Bear #7",distance=..1] unless entity @e[type=item,distance=..4,nbt={Item:{id:"minecraft:sea_pickle"}}] run scoreboard players set @a 1million 1
execute as @a at @s if entity @s[advancements={gg:bear=true,gg:backrooms=true},nbt=!{Inventory:[{id:"minecraft:sea_pickle"}]}] if entity @e[type=sheep,name="Bear #7",distance=..1] unless entity @e[type=item,distance=..4,nbt={Item:{id:"minecraft:sea_pickle"}}] run give @a sea_pickle{display:{Name:'[{"text": "Autographed Selfie","bold":true,"color": "yellow"}]',Lore:['{"text":"You GOT that from Bear #7!?!","color": "dark_purple","italic": true}','{"text":"That\'s gotta at least be worth $1,000,000","color": "dark_purple","italic": true}']}}
execute as @a at @s if entity @e[type=sheep,name="Bear #7",distance=..1] run advancement grant @a only gg:bear

#||Market Garden||
execute as @a[team=Alive,tag=BoomBow] at @s if entity @e[type=creeper,distance=..1] unless entity @e[type=armor_stand,tag=Fizzy,distance=..1] run advancement grant @s only gg:market_garden

#||A Great Immune System||
execute as @a[team=Alive,tag=InfectedBarbarian] at @s if entity @e[nbt={ActiveEffects:[{Id:20},{Id:11}]},distance=..3] run advancement grant @s only gg:a_great_immune_system

#||Double Secret||
execute as @a[team=Lobby] at @s if block ~ ~-2 ~ deepslate_copper_ore run advancement grant @s only gg:double_secret

#||Causes Unearthed||
execute as @a[team=Lobby] at @s if block ~ ~-2 ~ raw_gold_block run advancement grant @s only gg:causes_unearthed

#||What A Trooper||
execute if score Start Game matches 1 run scoreboard players remove Number AdvancementTimer 1
execute as @a[team=Alive] if score Number AdvancementTimer matches 0 run advancement grant @s only gg:what_a_trooper

#||I Thought This Was Safe||
execute as @a[team=Alive,tag=LightningSniper] at @s if entity @e[type=lightning_bolt,distance=..5.5] run advancement grant @s only gg:i_thought_this_was_safe

#==========
#Boss Fight
#==========

#||Boss Health||
execute if score Active BossFight matches 1 store result score @e[type=frog,name="Francis"] BossHealth run data get entity @e[type=frog,limit=1,name="Francis"] Health
execute if score Active BossFight matches 1 store result bossbar minecraft:francis value run scoreboard players get @e[type=frog,name="Francis",limit=1] BossHealth

#||Players Left||
scoreboard players set BossNumber PlayersLeft 0
execute as @a[team=AliveBoss] run scoreboard players add BossNumber PlayersLeft 1

#||Falling & Death||
execute as @a[team=AliveBoss] at @s if block ~ ~-1 ~ black_concrete run team join DeadBoss
execute as @a[team=DeadBoss] at @s if block ~ ~-1 ~ black_concrete run tp @s 84.5 14 -54.5
execute as @a[team=AliveBoss] at @s if score @s Elimination matches 1 run team join DeadBoss
execute as @a[team=DeadBoss] at @s if score @s Elimination matches 1 run tp @s 84.5 14 -54.5
scoreboard players set @a Elimination 0

#||Game Over||
execute if score Active BossFight matches 1 if score BossNumber PlayersLeft matches 0 run function gg:game_over

#||Boss Dead||
execute if score Active BossFight matches 1 unless entity @e[type=frog,name="Francis"] unless score BossNumber PlayersLeft matches 0 run schedule function gg:boss_dead 5t
execute if score Active BossFight matches 1 unless entity @e[type=frog,name="Francis"] unless score BossNumber PlayersLeft matches 0 run scoreboard players set Active BossFight 0

#||Actionbar||
execute as @a[team=AliveBoss] if score Active BossFight matches 1 unless score Active Ring matches 1 run title @s actionbar ["",{"text":"Ammo:","bold":true,"color":"green"},{"text":" ","color":"green"},{"score":{"objective":"Ammo","name": "@s"},"color":"green"},{"text":" Reload: ","bold":true,"color":"dark_green"},{"score":{"name":"@s","objective":"Reload"},"color":"dark_green"},{"text":"s ","color":"dark_green"},{"text":"Ability: ","bold":true,"color":"yellow"},{"score":{"name":"@s","objective":"AbilityCooldown"},"bold":false,"color":"yellow"},{"text":"s","color":"yellow","bold": false}]
